/*!
  \file   funciones.c
  \brief  Código de las funciones auxiliares
  \author Nicolás Luis Fernández García
  \date   17 de febrero de 2017
*/

#include <stdio.h>
#include <math.h>
#include <malloc.h>


#include "macros.h"

void erastotenes()
{
 int *primos, n, i, j, linea;

 /* Peticion del valor de n */
do {
    CLEAR_SCREEN;
    LUGAR(5,10);
    BBLUE;
    printf("Cálculo de los número primos menores que un número dado");
    RESET;

    LUGAR(6,10);
    YELLOW;
    printf("Introduce un numero natural:  n --> ");
    RESET;
    scanf("%d",&n); 
    getchar();
  } while (n<1);

 /* Reserva de memoria */
 primos = (int *) malloc (n * sizeof(int));

 /* Inicializacion del vector */
 for (i=0; i<n; i++) *(primos+i) = i+1;

/**********************************************************************
 Criba de Erastotenes 
 Version optimizada: solo se criba con los números primos 
                     menores o iguales que la raíz cuadrada de n 
************************************************************************/

 for (i=1; *(primos+i)<=sqrt(n); i++)
   if (*(primos+i) != 0) 
        for (j= 2 * *(primos+i) - 1; j<n; j+= *(primos+i))
             *(primos+j) = 0;

/* Presentacion de los números primos menores que n */
 CLEAR_SCREEN;
 LUGAR(1,5);
 BYELLOW;
 printf("Números primos menores que %d",n);
 RESET;

 for(i=0,linea=1;i<n;i++)
    { 
     /* Si el número es primo, se escribe por pantalla */
     if (*(primos+i)!=0) 
            {
             LUGAR(linea+2,10);
             printf("%d", *(primos+i)); 
             linea++; 
            }

     /* Si se llena la pantalla, la borra para empezar de nuevo */
     if (linea%20==0) 
           {
            LUGAR(linea+1,25);
            printf("pulse ");
				    UNDERLINE;
		  	    printf("ENTER");
				    RESET;
				    printf(" para ");
				    INVERSE;
				    printf(" continuar"); 
				    RESET;
            getchar();

            CLEAR_SCREEN; 
            linea = 1;
            LUGAR(linea,10);
				    INTENSITY;
            printf("Numeros primos menores que %d (continuación)",n);
				    RESET;
           }
    }
putchar('\n');

INTENSITY; 

LUGAR(linea+2,25);
printf("Fin de la lista de números primos menores que %d\n", n);

RESET;
/* Pausa */
getchar();
}


/*******************************************/
/*******************************************/
/*******************************************/

void factorial()
{
 int n;
 int resultado=1;
 int i;

 /* Peticion del valor de n */
 do {
    CLEAR_SCREEN;
    LUGAR(5,10);
    printf("Cálculo del factorial de un número");
    LUGAR(6,10);
    printf("Introduce un numero natural: n --> ");
    scanf("%d",&n); 
    getchar();
  } while (n<1);

 if ((n==0) || (n==1))
	resultado = 1;
 else {
	for(i=2;i<=n;i++)
	  resultado = resultado * i;
	}

 CLEAR_SCREEN;
 LUGAR(5,10);
 printf("El factorial de %d es %d",n,resultado);

 LUGAR(23,25);
 printf("pulse ");
 UNDERLINE;
 printf("ENTER");
 RESET;
 printf(" para ");
 INVERSE;
 printf(" continuar"); 
 RESET;
 getchar();

 CLEAR_SCREEN; 
}







